//
//  ViewController.swift
//  购物动画
//
//  Created by 吕中威 on 16/5/31.
//  Copyright © 2016年 吕中威. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var addBtn: UIButton!
    @IBOutlet weak var shopImageView: UIImageView!
    @IBOutlet weak var imageView: UIImageView!
    var animationLayers : [CALayer]?
    var animationBigLayers : [CALayer]?
    
    func addProductsAnimation(product : UIImageView) {
        
        if self.animationLayers == nil {
            
            self.animationLayers = [CALayer]();
        }
        
        let frame = product.convertRect(product.bounds, toView: view);
        let transitionLayer = CALayer();
        transitionLayer.frame = frame;
        transitionLayer.contents = product.layer.contents;
        self.view.layer.addSublayer(transitionLayer);
        self.animationLayers?.append(transitionLayer);
        
        let p1 = transitionLayer.position;
        let p3 = CGPointMake(view.frame.size.width - view.frame.size.width / 4 - view.frame.size.width / 8 ,self.view.layer.bounds.size.height - 60 );
        let positionAnimation = CAKeyframeAnimation(keyPath: "position");
        let path = CGPathCreateMutable();
        CGPathMoveToPoint(path, nil, p1.x, p1.y);
        CGPathAddCurveToPoint(path, nil, p1.x, p1.y - 30, p3.x, p1.y - 30, p3.x, p3.y);
        positionAnimation.path = path;
        
        let opacityAnimation = CABasicAnimation(keyPath: "opacity");
        opacityAnimation.fromValue = 1;
        opacityAnimation.toValue = 0.9;
        opacityAnimation.fillMode = kCAFillModeForwards;
        opacityAnimation.removedOnCompletion = true;
        
        let transformAnimation = CABasicAnimation(keyPath: "transform");
        transformAnimation.fromValue = NSValue(CATransform3D:CATransform3DIdentity);
        transformAnimation.toValue = NSValue(CATransform3D : CATransform3DScale(CATransform3DIdentity, 0.2, 0.2, 1));
        
        let groupAnimation = CAAnimationGroup();
        groupAnimation.animations = [positionAnimation,transformAnimation,opacityAnimation];
        groupAnimation.duration = 0.8;
        groupAnimation.delegate = self;
        transitionLayer.addAnimation(groupAnimation, forKey : "cartParabola");
    }
    override func animationDidStop(anim: CAAnimation, finished flag: Bool) {
        
        if self.animationLayers?.count > 0 {
            
            let transitonLayer = animationLayers![0];
            transitonLayer.hidden = true;
            transitonLayer.removeFromSuperlayer();
            animationLayers?.removeFirst();
            view.layer.removeAnimationForKey("cartParabola");
        }
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


    @IBAction func addShopAction(sender: AnyObject) {
        
        self.addProductsAnimation(self.imageView);
    }
}

